/*
	GridElement.h
	
	A Graphic Element used to break up large background pictures for faster updating. 
	
	Makes a basic PICT element, then clones it as necessary to convert it to a
	set of tiles with width elemWidth and height elemHeight.
	
	The elements created are assigned sequential IDs beginning at startID. 
	NewGridPICT returns the first element created.
	
	For convenience, the elements are linked through their masterGrafEl/slaveGrafEl
	fields. The element with ID startID is the head of the list.
	
	Copyright 1994 by Al Evans. All rights reserved.
	
	3/1/94
	
*/

#ifndef GRIDELEMENT
#define GRIDELEMENT

#include "GraphElements.h"

#ifdef __cplusplus
extern "C" {
#endif

GrafElPtr NewGridPICT(GEWorldPtr world, OSType startID, short plane, short resNum,
							short mode, short xPos, short yPos, short elemWidth,
							short elemHeight);
							

#ifdef __cplusplus
}
#endif


#endif