/*
	NullGE.h
	
	A "non-existent" Graphic Element.
	
	Two suggested uses:
	
	1) Can be used as an invisible "roll-over", with a CollisionProc
	   which, for example, does something to the colliding element.
	   
	2) Can be slaved to a visible Graphic Element and assigned a
	   CollisionProc, for example to create a collision rectangle
	   which is different in size or location from that element's
	   animationRect.
	   
	Copyright 1994 by Al Evans. All rights reserved.
	
	3/25/94
*/

#ifndef NULLELEMENT
#define NULLELEMENT

#include "GraphElements.h"

#ifdef __cplusplus
extern "C" {
#endif

GrafElPtr NewNullElement(GEWorldPtr world, OSType id, short plane, Rect *animRect);

#ifdef __cplusplus
}
#endif

