/**********************************************************************\

File:		error.c

Purpose:	This module handles altering the user when an error has
			occurred.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "error.h"
#include "dialogs.h"
#include "environment.h"
#include "util.h"

void HandleError(short resultCode)
/* All error codes are listed in program globals.h */
{
	Str255			tempStr;
	
	if (resultCode==0) return;
	
	GetIndString(tempStr, 129, resultCode);	/* get error string from .rsrc */
	ParamText(tempStr, "\p", "\p", "\p");
	
	PositionDialog('ALRT', largeAlert);		/* position alert (see dialogs.c) */
	StopAlert(largeAlert, 0L);				/* show it */
	
	ExitToShell();
}
