/**********************************************************************\

File:		file interface.c

Purpose:	This module handles the standard file package (open & save
			dialogs) and returns an FSSpec to deal with.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "file interface.h"
#include "environment.h"
#include "util.h"

pascal OSErr MyMakeFSSpec(short vRefNum, long parID, Str255 fileName,
	FSSpecPtr myFSS)
/* a standard function for creating an FSSpec out of its three component parts.
   if the system supports FSSpecs, we let it do the work; otherwise we have to
   do it manually. */
{
	if (gHasFSSpecs)
		return FSMakeFSSpec(vRefNum, parID, fileName, myFSS);
	else
	{
		myFSS->vRefNum=vRefNum;
		myFSS->parID=parID;
		Mymemcpy((Ptr)(myFSS->name), (Ptr)fileName, fileName[0]+1);
	}
	
	return noErr;
}
