/**********************************************************************\

File:		sfx.c

Purpose:	This module is a dispatch for installing the shutdown
			procs and fade module.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "sfx.h"
#include "sfx meat.h"
#include "sfx install.h"
#include "sfx gestalt.h"
#include "program globals.h"
#include "prefs.h"

short			gModuleIndex;
char			gChooseRandom, gOnRestart, gOnShutdown, gFadeEarly;

short DoSetup(void)
{
	short			resultCode;
	short			vRefNum;
	long			dirID;
	Str255			theName;
	
	resultCode=PreferencesInit();
	if ((resultCode!=prefs_allsWell) && (resultCode!=prefs_virginErr))
		return kPrefsError;
	
	if ((resultCode=GetAModule(&gModuleIndex, theName, &vRefNum, &dirID))!=0)
		return resultCode;
	
	if (!sfxGestaltFunctionInstalledQQ())
	{
		if ((resultCode=MakeNewGestaltSelectors())!=0)
			return resultCode;
		if ((resultCode=InstallTheShutdownProc(theName, vRefNum, dirID, gOnShutdown,
				gOnRestart, gFadeEarly))!=0)
			return resultCode;
		
		SaveThePrefs();
	}
	
	return 0;
}
